"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  default: () => solidReactivityPlugin
});

// src/label-parser.ts
var t5 = __toModule(require("@babel/types"));

// src/get-hook-identifier.ts
var import_helper_module_imports = __toModule(require("@babel/helper-module-imports"));
function getHookIdentifier(hooks, path, name) {
  const current = hooks.get(name);
  if (current) {
    return current;
  }
  const newID = (0, import_helper_module_imports.addNamed)(path, name, "solid-js");
  hooks.set(name, newID);
  return newID;
}

// src/memo-variable.ts
var t2 = __toModule(require("@babel/types"));

// src/deref-memo-expression.ts
var t = __toModule(require("@babel/types"));
function derefMemoExpression(path, memoIdentifier, readIdentifier) {
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      CallExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (!t.isIdentifier(p.node.callee)) {
          return;
        }
        switch (p.node.callee.name) {
          case "$refMemo":
            if (!t.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === memoIdentifier.name) {
              p.replaceWith(readIdentifier);
            }
            break;
          case "$get":
            if (!t.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === memoIdentifier.name) {
              p.replaceWith(readIdentifier);
            }
            break;
          default:
            break;
        }
      },
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t.isIdentifier(p.node.key) && p.node.key.name === memoIdentifier.name && t.isIdentifier(p.node.value) && p.node.value.name === memoIdentifier.name) {
          p.replaceWith(t.objectProperty(memoIdentifier, t.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== memoIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (t.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isVariableDeclarator(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t.callExpression(readIdentifier, []));
      }
    });
  }
}

// src/memo-variable.ts
function memoVariableExpression(hooks, path, memoIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  path.node.id = readIdentifier;
  path.node.init = t2.callExpression(getHookIdentifier(hooks, path, "createMemo"), [
    t2.arrowFunctionExpression([], stateIdentifier),
    t2.objectExpression([
      t2.objectProperty(t2.identifier("name"), t2.stringLiteral(memoIdentifier.name))
    ])
  ]);
  derefMemoExpression(path, memoIdentifier, readIdentifier);
}

// src/signal-variable.ts
var t4 = __toModule(require("@babel/types"));

// src/deref-signal-expression.ts
var t3 = __toModule(require("@babel/types"));
function derefSignalExpression(path, signalIdentifier, readIdentifier, writeIdentifier) {
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      CallExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (!t3.isIdentifier(p.node.callee)) {
          return;
        }
        switch (p.node.callee.name) {
          case "$refSignal":
            if (!t3.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === signalIdentifier.name) {
              p.replaceWith(t3.arrayExpression([
                readIdentifier,
                writeIdentifier
              ]));
            }
            break;
          case "$get":
            if (!t3.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === signalIdentifier.name) {
              p.replaceWith(readIdentifier);
            }
            break;
          case "$set":
            if (!t3.isIdentifier(p.node.arguments[0])) {
              throw new Error("Expected identifier");
            }
            if (p.node.arguments[0].name === signalIdentifier.name) {
              p.replaceWith(writeIdentifier);
            }
            break;
          default:
            break;
        }
      },
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t3.isIdentifier(p.node.key) && p.node.key.name === signalIdentifier.name && t3.isIdentifier(p.node.value) && p.node.value.name === signalIdentifier.name) {
          p.replaceWith(t3.objectProperty(signalIdentifier, t3.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== signalIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t3.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t3.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t3.isVariableDeclarator(p.parent)) {
          if (p.parent.id === p.node) {
            return;
          }
        }
        if (t3.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t3.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t3.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t3.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t3.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t3.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t3.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t3.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t3.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t3.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t3.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t3.callExpression(readIdentifier, []));
      },
      UpdateExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t3.isIdentifier(p.node.argument) && p.node.argument.name === signalIdentifier.name) {
          const param = p.scope.generateUidIdentifier("current");
          if (p.node.prefix) {
            p.replaceWith(t3.callExpression(writeIdentifier, [
              t3.arrowFunctionExpression([param], t3.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t3.numericLiteral(1)))
            ]));
          } else {
            p.replaceWith(t3.callExpression(t3.arrowFunctionExpression([], t3.blockStatement([
              t3.variableDeclaration("const", [
                t3.variableDeclarator(param, t3.callExpression(readIdentifier, []))
              ]),
              t3.expressionStatement(t3.callExpression(writeIdentifier, [
                t3.arrowFunctionExpression([], t3.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t3.numericLiteral(1)))
              ])),
              t3.returnStatement(param)
            ])), []));
          }
        }
      },
      AssignmentExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        const identifier5 = p.node.left;
        const expression = p.node.right;
        if (t3.isIdentifier(identifier5) && identifier5.name === signalIdentifier.name) {
          if (p.node.operator === "=") {
            p.replaceWith(t3.callExpression(writeIdentifier, [
              t3.arrowFunctionExpression([], expression)
            ]));
          } else {
            const param = p.scope.generateUidIdentifier("current");
            p.replaceWith(t3.callExpression(writeIdentifier, [
              t3.arrowFunctionExpression([param], t3.assignmentExpression(p.node.operator, param, expression))
            ]));
          }
        }
      }
    });
  }
}

// src/signal-variable.ts
function signalVariableExpression(hooks, path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  path.node.id = t4.arrayPattern([
    readIdentifier,
    writeIdentifier
  ]);
  path.node.init = t4.callExpression(getHookIdentifier(hooks, path, "createSignal"), [
    stateIdentifier,
    t4.objectExpression([
      t4.objectProperty(t4.identifier("name"), t4.stringLiteral(signalIdentifier.name))
    ])
  ]);
  derefSignalExpression(path, signalIdentifier, readIdentifier, writeIdentifier);
}

// src/label-parser.ts
function signalExpression(hooks, path) {
  const { body } = path.node;
  if (t5.isExpressionStatement(body)) {
    if (t5.isAssignmentExpression(body.expression)) {
      if (body.expression.operator !== "=") {
        throw new Error("Invalid assignment expression operator");
      }
      const leftExpr = body.expression.left;
      const rightExpr = body.expression.right;
      if (!t5.isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      path.replaceWith(t5.variableDeclaration("const", [
        t5.variableDeclarator(leftExpr, rightExpr)
      ]));
    } else if (t5.isIdentifier(body.expression)) {
      path.replaceWith(t5.variableDeclaration("const", [
        t5.variableDeclarator(body.expression)
      ]));
    } else if (t5.isSequenceExpression(body.expression)) {
      const exprs = [];
      for (let i = 0, len = body.expression.expressions.length; i < len; i += 1) {
        const expr = body.expression.expressions[i];
        if (t5.isIdentifier(expr)) {
          exprs.push(t5.variableDeclarator(expr));
        } else if (t5.isAssignmentExpression(expr)) {
          if (expr.operator !== "=") {
            throw new Error("Invalid assignment expression operator");
          }
          const leftExpr = expr.left;
          const rightExpr = expr.right;
          if (!t5.isIdentifier(leftExpr)) {
            throw new Error("Expected identifier");
          }
          path.replaceWith(t5.variableDeclarator(leftExpr, rightExpr));
        } else {
          throw new Error("Expected identifier or assignment expression");
        }
      }
      path.replaceWith(t5.variableDeclaration("const", exprs));
    }
  }
  if (t5.isVariableDeclaration(body)) {
    body.kind = "const";
    path.replaceWith(body);
  }
  if (t5.isVariableDeclaration(path.node)) {
    path.traverse({
      VariableDeclarator(p) {
        const leftExpr = p.node.id;
        const rightExpr = p.node.init;
        if (t5.isIdentifier(leftExpr)) {
          signalVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : t5.identifier("undefined"));
        }
      }
    });
  } else {
    throw new Error("Expected assignment expression or variable declaration");
  }
}
function reactiveExpression(hooks, path) {
  const { body } = path.node;
  if (t5.isExpressionStatement(body)) {
    path.replaceWith(t5.callExpression(getHookIdentifier(hooks, path, "createEffect"), [
      t5.arrowFunctionExpression([], body.expression)
    ]));
  } else if (t5.isBlockStatement(body)) {
    path.replaceWith(t5.callExpression(getHookIdentifier(hooks, path, "createEffect"), [
      t5.arrowFunctionExpression([], body)
    ]));
  } else if (t5.isVariableDeclaration(body)) {
    body.kind = "const";
    path.replaceWith(body);
    path.traverse({
      VariableDeclarator(p) {
        const leftExpr = p.node.id;
        const rightExpr = p.node.init;
        if (t5.isIdentifier(leftExpr)) {
          memoVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : t5.identifier("undefined"));
        }
      }
    });
  }
}
function memoExpression(hooks, path) {
  const { body } = path.node;
  if (t5.isExpressionStatement(body)) {
    if (t5.isAssignmentExpression(body.expression)) {
      if (body.expression.operator !== "=") {
        throw new Error("Invalid assignment expression operator");
      }
      const leftExpr = body.expression.left;
      const rightExpr = body.expression.right;
      if (!t5.isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      path.replaceWith(t5.variableDeclaration("const", [
        t5.variableDeclarator(leftExpr, rightExpr)
      ]));
    } else if (t5.isIdentifier(body.expression)) {
      path.replaceWith(t5.variableDeclaration("const", [
        t5.variableDeclarator(body.expression)
      ]));
    } else if (t5.isSequenceExpression(body.expression)) {
      const exprs = [];
      for (let i = 0, len = body.expression.expressions.length; i < len; i += 1) {
        const expr = body.expression.expressions[i];
        if (t5.isIdentifier(expr)) {
          exprs.push(t5.variableDeclarator(expr));
        } else if (t5.isAssignmentExpression(expr)) {
          if (expr.operator !== "=") {
            throw new Error("Invalid assignment expression operator");
          }
          const leftExpr = expr.left;
          const rightExpr = expr.right;
          if (!t5.isIdentifier(leftExpr)) {
            throw new Error("Expected identifier");
          }
          path.replaceWith(t5.variableDeclarator(leftExpr, rightExpr));
        } else {
          throw new Error("Expected identifier or assignment expression");
        }
      }
      path.replaceWith(t5.variableDeclaration("const", exprs));
    }
  }
  if (t5.isVariableDeclaration(body)) {
    body.kind = "const";
    path.replaceWith(body);
  }
  if (t5.isVariableDeclaration(path.node)) {
    path.traverse({
      VariableDeclarator(p) {
        const leftExpr = p.node.id;
        const rightExpr = p.node.init;
        if (t5.isIdentifier(leftExpr)) {
          memoVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : t5.identifier("undefined"));
        }
      }
    });
  } else {
    throw new Error("Expected assignment expression or variable declaration");
  }
}
function createCallbackLabel(label) {
  return function expr(hooks, path) {
    const { body } = path.node;
    let callback;
    if (t5.isBlockStatement(body)) {
      callback = t5.arrowFunctionExpression([], body);
    } else if (t5.isExpressionStatement(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(t5.callExpression(getHookIdentifier(hooks, path, label), [
      callback
    ]));
  };
}
var EXPRESSIONS = {
  $: reactiveExpression,
  signal: signalExpression,
  memo: memoExpression,
  effect: createCallbackLabel("createEffect"),
  computed: createCallbackLabel("createComputed"),
  renderEffect: createCallbackLabel("createRenderEffect"),
  mount: createCallbackLabel("onMount"),
  cleanup: createCallbackLabel("onCleanup"),
  error: createCallbackLabel("onError"),
  root: createCallbackLabel("createRoot"),
  untrack: createCallbackLabel("untrack"),
  batch: createCallbackLabel("batch")
};
var LABEL_PARSER = {
  LabeledStatement(path, state) {
    if (path.node.label.name in EXPRESSIONS) {
      EXPRESSIONS[path.node.label.name](state.hooks, path);
    }
  }
};
var label_parser_default = LABEL_PARSER;

// src/comment-parser.ts
var t6 = __toModule(require("@babel/types"));
function signalExpression2(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (t6.isIdentifier(leftExpr)) {
        signalVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : t6.identifier("undefined"));
      }
    }
  });
}
function memoExpression2(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (t6.isIdentifier(leftExpr)) {
        memoVariableExpression(hooks, p, leftExpr, rightExpr != null ? rightExpr : t6.identifier("undefined"));
      }
    }
  });
}
function createCallbackLabel2(label) {
  return function expr(hooks, path) {
    const body = path.node;
    let callback;
    if (t6.isBlockStatement(body)) {
      callback = t6.arrowFunctionExpression([], body);
    } else if (t6.isExpressionStatement(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(t6.callExpression(getHookIdentifier(hooks, path, label), [
      callback
    ]));
  };
}
var STATE_EXPRESSIONS = {
  "@signal": signalExpression2,
  "@memo": memoExpression2
};
var CALLBACK_EXPRESSIONS = {
  "@effect": createCallbackLabel2("createEffect"),
  "@computed": createCallbackLabel2("createComputed"),
  "@renderEffect": createCallbackLabel2("createRenderEffect"),
  "@mount": createCallbackLabel2("onMount"),
  "@cleanup": createCallbackLabel2("onCleanup"),
  "@error": createCallbackLabel2("onError"),
  "@root": createCallbackLabel2("createRoot"),
  "@untrack": createCallbackLabel2("untrack"),
  "@batch": createCallbackLabel2("batch")
};
var COMMENT_PARSER = {
  VariableDeclaration(path, state) {
    const comments = path.node.leadingComments;
    if (comments) {
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in STATE_EXPRESSIONS) {
          preference = value;
        }
      }
      if (preference) {
        STATE_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  BlockStatement(path, state) {
    var _a, _b;
    if (t6.isFunctionDeclaration(path.parent)) {
      return;
    }
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      t6.removeComments(path.node);
      t6.addComments(path.node, "leading", leading);
      t6.addComments(path.node, "inner", inner);
      t6.addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  ExpressionStatement(path, state) {
    var _a, _b;
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      t6.removeComments(path.node);
      t6.addComments(path.node, "leading", leading);
      t6.addComments(path.node, "inner", inner);
      t6.addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  }
};
var comment_parser_default = COMMENT_PARSER;

// src/ctf-parser.ts
var t8 = __toModule(require("@babel/types"));

// src/deref-signal-variable.ts
var t7 = __toModule(require("@babel/types"));
function derefSignalVariableExpression(path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  path.node.id = t7.arrayPattern([
    readIdentifier,
    writeIdentifier
  ]);
  path.node.init = stateIdentifier;
  derefSignalExpression(path, signalIdentifier, readIdentifier, writeIdentifier);
}

// src/deref-memo-variable.ts
function derefMemoVariableExpression(path, memoIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  path.node.id = readIdentifier;
  path.node.init = stateIdentifier;
  derefMemoExpression(path, memoIdentifier, readIdentifier);
}

// src/ctf-parser.ts
function derefSignalExpression2(_, path) {
  const argument = path.node.arguments[0];
  if (!t8.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!t8.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t8.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  derefSignalVariableExpression(path.parentPath, leftExpr, argument);
}
function signalExpression3(hooks, path) {
  const argument = path.node.arguments[0];
  if (!t8.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!t8.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t8.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  signalVariableExpression(hooks, path.parentPath, leftExpr, argument);
}
function derefMemoExpression2(_, path) {
  const argument = path.node.arguments[0];
  if (!t8.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!t8.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t8.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  derefMemoVariableExpression(path.parentPath, leftExpr, argument);
}
function memoExpression3(hooks, path) {
  const argument = path.node.arguments[0];
  if (!t8.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (!t8.isVariableDeclarator(path.parent) || !path.parentPath) {
    throw new Error("Expected variable declarator");
  }
  const leftExpr = path.parent.id;
  if (!t8.isIdentifier(leftExpr)) {
    throw new Error("Expected identifier");
  }
  memoVariableExpression(hooks, path.parentPath, leftExpr, argument);
}
function reactiveExpression2(hooks, path) {
  if (!path.parentPath) {
    throw new Error("Expected parent path");
  }
  const argument = path.node.arguments[0];
  if (!t8.isExpression(argument)) {
    throw new Error("Expected expression");
  }
  if (t8.isVariableDeclarator(path.parent)) {
    const leftExpr = path.parent.id;
    if (!t8.isIdentifier(leftExpr)) {
      throw new Error("Expected identifier");
    }
    memoVariableExpression(hooks, path.parentPath, leftExpr, argument);
  } else if (t8.isExpressionStatement(path.parent)) {
    path.replaceWith(t8.callExpression(getHookIdentifier(hooks, path, "createEffect"), [
      t8.arrowFunctionExpression([], argument)
    ]));
  } else {
    throw new Error("Expected expression statement or variable declarator.");
  }
}
function createCompileTimeFunction(target) {
  return (hooks, path) => {
    const argument = path.node.arguments[0];
    if (t8.isExpression(argument)) {
      path.replaceWith(t8.callExpression(getHookIdentifier(hooks, path, target), [
        t8.arrowFunctionExpression([], argument)
      ]));
    } else {
      throw new Error("Expected expression");
    }
  };
}
var CTF_EXPRESSIONS = {
  $: reactiveExpression2,
  $derefSignal: derefSignalExpression2,
  $derefMemo: derefMemoExpression2,
  $signal: signalExpression3,
  $memo: memoExpression3,
  $untrack: createCompileTimeFunction("untrack"),
  $batch: createCompileTimeFunction("batch")
};
var CTF_PARSER = {
  CallExpression(path, state) {
    if (t8.isIdentifier(path.node.callee) && path.node.callee.name in CTF_EXPRESSIONS) {
      CTF_EXPRESSIONS[path.node.callee.name](state.hooks, path);
    }
  }
};
var ctf_parser_default = CTF_PARSER;

// src/index.ts
function solidReactivityPlugin() {
  return {
    pre() {
      this.hooks = new Map();
    },
    visitor: __spreadValues(__spreadValues(__spreadValues({}, label_parser_default), comment_parser_default), ctf_parser_default)
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
//# sourceMappingURL=index.js.map
